#include <iostream.h>

struct Node
{
	int   Key;
	float Bal; // .
	Node* Left;
	Node* Right;
};

class Tree
{
  private:
		Node* Root;   //   .
		float BalMin; //  .
  public:
		Tree() { Root = NULL; BalMin = 1;};
		void PrintTreeBal (Node*, int);
		void FibonTree1 (int, Node**);
		void FibonTree2 (Node**,int *);
		int  NodeCount (Node*);
		Node** GetTree() {return &Root;};
		Node* GetTree1() {return Root;};
		int GetBalMin() {return BalMin;};
};

// ------------    ----------

void Tree::PrintTreeBal (Node* W, int l)
//  p p  p   
//       p.
{
  int i;

  if  (W!=NULL)
  {
	 PrintTreeBal (W->Right,l+1);
	 for (i=1;i<=l;i++) cout << "   ";
	 W->Bal = (float)(NodeCount (W->Left)+1)/(float)(NodeCount (W)+1);
	 if ( BalMin > W->Bal) BalMin = W->Bal;
	 cout << W->Key << '('<< W->Bal << ')' << endl;
	 PrintTreeBal (W->Left,l+1);
  }
}

void Tree::FibonTree1 (int k, Node** T)
//     k  
//  Key .
{
  if ( k==0)  (*T) = NULL;
  else
	if ( k==1 )
	 {
		(*T) = new (Node);
		(*T)->Left = (*T)->Right = NULL;
	 }
	else
	 {
		(*T) = new (Node);
		FibonTree1 (k-1,&((*T)->Left));
		FibonTree1 (k-2,&((*T)->Right));
	 }
}

void Tree::FibonTree2 (Node** T,int* i)
//   Key   .
{
  if ( (*T)!=NULL )
  {
	  FibonTree2 (&((*T)->Left),i);
	  (*T)->Key = (*i); (*i)++;
	  FibonTree2 (&((*T)->Right),i);
  }
}

int Tree::NodeCount (Node* T)
//     p p T.
{
  if ( T==NULL ) return 0;
  else
	 if  (T->Left==NULL && T->Right==NULL) return 1;
	 else
		  return NodeCount(T->Right)+NodeCount(T->Left)+1;
}

void main()
{
  Tree A;
  int k;
  cout << " k...";
  cin >> k;
  //  .
  int i = 1; //     .
  A.FibonTree1 (k,A.GetTree());
  A.FibonTree2 (A.GetTree(),&i);
  //  ,     .
  A.PrintTreeBal (A.GetTree1(),0);
  cout << "\n  : " << A.GetBalMin();
}